<?php
/**
 * Webkul MarketingCloud Magento Connector SyncAllCategory Controller
 * @category  Webkul
 * @package   Webkul_MarketingCloudMagentoConnector
 * @author    Webkul
 * @copyright Copyright (c) 2010-2017 Webkul Software Private Limited (https://webkul.com)
 * @license   https://store.webkul.com/license.html
 */

namespace Webkul\MarketingCloudMagentoConnector\Controller\Adminhtml\Category;

use Magento\Backend\App\Action;
use Magento\Ui\Component\MassAction\Filter;
use Magento\Framework\Controller\ResultFactory;

class SyncAllCategory extends \Magento\Backend\App\Action
{
    /**
     * @var \Magento\Backend\Model\View\Result\Forward
     */
    protected $_filter;
    protected $_resultForwardFactory;

    /**
     * @param \Magento\Backend\App\Action\Context $context
     * @param \Magento\Backend\Model\View\Result\ForwardFactory $resultForwardFactory
     */
    public function __construct(
        Filter $filter,
        \Magento\Backend\App\Action\Context $context,
        \Magento\Catalog\Model\Category $categoryModel,
        \Magento\Framework\Message\ManagerInterface $messageManager,
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
        \Webkul\MarketingCloudMagentoConnector\Helper\Connection $connection,
        \Magento\Backend\Model\View\Result\ForwardFactory $resultForwardFactory
    ) {
        parent::__construct($context);
        $this->_filter = $filter;
        $this->_connection = $connection;
        $this->_scopeConfig = $scopeConfig;
        $this->_categoryModel = $categoryModel;
        $this->_messageManager = $messageManager;
        $this->_resultForwardFactory = $resultForwardFactory;
    }

    /**
     * Forward to edit
     *
     * @return \Magento\Backend\Model\View\Result\Forward
     */
    public function execute()
    {
        $helper = $this->_connection;
        $params = $this->getRequest()->getParams();
        $categoryId = $params['categoryId'];
        $helper = $this->_connection;
        $res = $helper->getAutoSyncAllCategory([$categoryId]);
        // die($res);
        if ($res && $res[0]) {
            // $this
            // ->_connection
            // ->eshopsyncLog('Subscriber Export Sucess : '.$subscriberId . ' Exported Successfully to Maketing Cloud');
            
            $this->getResponse()->setHeader('Content-type', 'application/json');
            $this->getResponse()->setBody(1);
        } else {
            // $this
            // ->_connection
            // ->eshopsyncLog('Subscriber Export Error : '.$subscriberId . ' Not Exported '.$res[1]);
            $this->getResponse()->setHeader('Content-type', 'application/json');
            $this->getResponse()->setBody(0);
        }
    }
}