<?php
/**
 * Copyright © Magento, Inc. All rights reserved.
 * See COPYING.txt for license details.
 */
namespace Webkul\MarketingCloudMagentoConnector\Model\Config\Source;

/**
 * @api
 * @since 100.0.2
 */
class McList implements \Magento\Framework\Option\ArrayInterface
{

    protected $_scopeConfig;
    /**
     * Construct
     *
     * @param \Magento\Framework\Model\ResourceModel\Db\Context $context
     * @param string|null $resourcePrefix
     */
    public function __construct(
        \Webkul\MarketingCloudMagentoConnector\Helper\Connection $connection
    ) {
        $this->_helper = $connection;
    }

    /**
     * Options getter
     *
     * @return array
     */
    public function toOptionArray()
    {
        $mcListData = array();
        $helper = $this->_helper;
        $results = $helper->callMcMethod();
        
        if($results){
            $mcListData[''] ='--Select Mc List--';
            foreach($results as $result){
                if (property_exists($result, 'ID') && property_exists($result, 'ListName')) {
                    $mcListData[] = [
                        'value'=> $result->ID,
                        'label'=> $result->ListName
                    ];
                }
            }
        } else {
            $mcListData[] = [
                'value' => 'Set Username, Password, Subdomain First',
                'label' => 'Set Username, Password, Subdomain First'
            ];
        }
        return $mcListData;
    }
}
